##### super teach Logistic Regression regression #####

#Parameters
param N; # Number of training items
param lambda:=0.1; # L2 regularization parameter of the learner
param d; # dimension of training items
param s1; # Lower bound of number of items
param s2; # Upper bound of number of items
param theta_star{i in 1..d}; # target concept
param x{i in 1..N, j in 1..d}:= Normal01(); # Training data iid Gaussian
param y{i in 1..N}:= round(sum{j in 1..d}x[i,j]*theta_star[j]/10000+0.5)*2-1;
param pi := 4 * atan(1);
# Variables
var b{i in 1..N} binary; #indicator of whether to choose training item i
var theta{i in 1..d};

# Objective
minimize risk: if (sum{j in 1..d} abs(theta[j])=0) then 0.5 else acos((sum{j in 1..d} theta[j]*theta_star[j])/(sqrt(sum{j in 1..d}(theta[j]^2))*sqrt(sum{j in 1..d}(theta_star[j]^2))))/pi;

# Constraints
subject to learner{s in 1..d}: (-sum{i in 1..N} (b[i]/(1+exp(y[i]*(sum{j in 1..d} (x[i,j]*theta[j]))))*y[i]*x[i,s])) + lambda*theta[s]=0;
subject to var: s1<=(sum{i in 1..N} b[i])<=s2;
