##### super teach Ridge Regression regression #####

#Parameters
param N; # Number of training items
param lambda:=0.1; # L2 regularization parameter of the learner
param d; # dimension of training items
param s1; # Lower bound of number of items
param s2; # Upper bound of number of items
param theta_star{i in 1..d}; # target concept
param x{i in 1..N, j in 1..d}:= Normal01(); # Training data iid Gaussian
param sigma:=0.1; # variance of error in y = theta*x + epsilon
param y{i in 1..N}:=Normal((sum{j in 1..d} x[i,j]*theta_star[j]), sigma);

# Variables
var b{i in 1..N} binary; #indicator of whether to choose training item i
var theta{i in 1..d};

# Objective
minimize risk: sqrt(sum{i in 1..d} (theta[i]-theta_star[i])^2);

# Constraints
subject to learner{k in 1..d}: (sum{i in 1..N} (b[i]*(2*x[i,k]*(sum{j in 1..d} (x[i,j]*theta[j]))-2*x[i,k]*y[i])))+lambda*theta[k]=0;
subject to var: s1<=(sum{i in 1..N} b[i])<=s2;